/**
* Carlos O. Rios (gth700w)
* Collaboration Statement: I worked on the homework assignment alone, using only course materials.
* This code is a modified version of code provided through the course textbook.
*/

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
* Summary: This method created a JFrame with JButtons that control the speed of a moving image
*  which bounces on the edges of the JFrame.
*
* @author Carlos O. Rios (gth700w)
* @version 1.0
*/
public class ReboundPanel extends JPanel
{

	//NOTE: WIDTH and HEIGHT are the default dimensions when the programs runs.
   private final int WIDTH = 300, HEIGHT = 100;
	private int width, height, delay = 20, count = 0;
   private final int DELAY = 20, IMAGE_SIZE = 35;
	private JButton fasterButton, slowerButton, pauseAndPlayButton;
   private ImageIcon image;
   private Timer timer;
   private int x, y, moveX, moveY;

   /**
	* Sets up the panel, including the timer for the animation.
   */
   public ReboundPanel()
   {
      timer = new Timer(DELAY, new ReboundListener());
		
		//image is the variable that the smily face image will be called
      image = new ImageIcon ("happyFace.gif");

      x = 0;
      y = 40;
      moveX = moveY = 3;

		//This creates the background of the canvas
      setPreferredSize (new Dimension(WIDTH, HEIGHT));
      setBackground (Color.black);
		//Making the timer start whe nthe fram opens
      timer.start();

		//Creating the JButtons that will make the image move faster, slower, or pause/play.	
		fasterButton = new JButton("Faster");
		slowerButton  = new JButton("Slower");
		pauseAndPlayButton  = new JButton("Pause");

		//Adding the new JButtons to the Panel		
		add(fasterButton);
		add(slowerButton);
		add(pauseAndPlayButton);

		//Adding the JButtons to the ActionListener class below so that they have a function/result when clicked		
		fasterButton.addActionListener(new ButtonListener());
		slowerButton.addActionListener(new ButtonListener());
		pauseAndPlayButton.addActionListener(new ButtonListener());
   }

   /**
   * Draws the image in the current location.
	*/
   public void paintComponent (Graphics page)
   {
      super.paintComponent (page);
		page.drawRect(x,y,IMAGE_SIZE, IMAGE_SIZE);
      image.paintIcon (this, page, x, y);
   }

   /**
   * Represents the action listener for the timer.
	*/
   private class ReboundListener implements ActionListener
   {
      /**
      * Updates the position of the image and possibly the direction
      *  of movement whenever the timer fires an action event.
		*/
      public void actionPerformed (ActionEvent event)
      {
         x += moveX;
         y += moveY;
		 width = getWidth();
		 height = getHeight();
		  

         if (x <= 0 || x >= width-IMAGE_SIZE)
            moveX = moveX * -1;

         if (y <= 0 || y >= height-IMAGE_SIZE)
            moveY = moveY * -1;
    
         repaint();
      }
   }

	/**
	* This class creates the conditionals for the JButtons added earlier. When a certain button is clicked,
	*  a designated action/result will occur.
	*/
	private class ButtonListener implements ActionListener
		{
			public void actionPerformed(ActionEvent event)
			{
				if(event.getSource() == fasterButton && delay > 0)
				{
					delay -= 5;
					timer.setDelay(delay);
				}
				if(event.getSource() == slowerButton)
				{
					delay += 5;
					timer.setDelay(delay);
				}
				if(event.getSource() == pauseAndPlayButton)
				{
					if(count%2 == 0)
					{
						pauseAndPlayButton.setText("Play");
						timer.stop();
						count++;
					}
					else
					{
						pauseAndPlayButton.setText("Pause");
						timer.start();
						count++;
					}
				}
			}
		}
}
